[![NPM version](https://badge.fury.io/js/spur-ioc.png)](http://badge.fury.io/js/spur-ioc)
[![Build Status](https://travis-ci.org/SpurFramework/spur-ioc.png?branch=master)](https://travis-ci.org/SpurFramework/spur-ioc)

#Introduction

Dependency Injection Framework for [Node.js](http://nodejs.org/).

###Status

Spur-IoC is still a work in progress. We are in the middle of making adjustments prior to dogfooding the module in our own applications.

#Topics

- [Features](#features)
- [Quick start](#quick-start)
- [API Reference](API.md)
- [Examples](#examples)
    - [Coffee-Script: Express.js Web Server](https://github.com/SpurFramework/spur-express-coffee-example)
    - [JavaScript: Express.js Web Server](https://github.com/SpurFramework/spur-express-js-example)
- [What is inversion of control and why you should use it?](#what-is-inversion-of-control-and-why-you-should-use-it)
- [Development](#development)
    - [Testing](#testing)
    - [Styleguide](#styleguide)
- [License](#license)
- [Changelog](#changelog)
- [Contributing](#contributing)

#Features

  * Dependency injection (IoC)
  * ...


#Quick start

```bash
$ npm install spur-ioc
```

Then:

```javascript

```

For

#Examples

In order to illustrate how to use Spur IoC, we created sample apps in both Coffee-Script and JavaScript. We will be building out a more elaborate application sample, so please check back soon.

 * [Coffee-Script: Express.js Web Server](https://github.com/SpurFramework/spur-express-coffee-example)
 * [JavaScript: Express.js Web Server](https://github.com/SpurFramework/spur-express-js-example)

#What is inversion of control and why you should use it?

Inversion of Control (IoC) is also known as Dependency Injection (DI). IoC is a pattern in which objects define their external dependencies through constructor arguments or the use of a container factory.

...

#Development

...

##Testing

To run the test suite, first install the dependancies, then run `npm test`:

```bash
$ npm install
$ npm test
```

##Styleguide

...

#License

[MIT](LICENSE)

#Changelog

  * Initial commit

#Contributing

...
